// NF startup
#include "pch.h"

#include "nf/config.h"
#include "version.h"
#include "util.h"
#include "client/Client.h"

// Enable visual styles for error boxes
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

namespace nf {
    void runEngine(ClientConfig config) {
        std::string engineStr = std::format("Nothin' Fancy {}", NFVERSION);
        std::string gameStr = std::format("{} {}", config.appName, config.appVersion);
        NFLog(engineStr);
        NFLog(std::format("Starting {}", gameStr));

#ifdef _DEBUG
        SetThreadDescription(GetCurrentThread(), L"NF Main Thread");
        SetConsoleTitle(std::format("{} Debug Console - {}", engineStr, gameStr).c_str());
#endif

        // Start client
        {
            client::Client client(config);
            client.run();
        }

        NFLog("Engine shutdown");
    }
}
